process reloj_digit (x,y,z,file,graph)
begin
    signal(id,s_freeze);
    frame;
end

process reloj (x,y,z,file)    //ANCHO TOTAL: 156
private
    int hijos[7];
begin
    priority=10;
    hijos[0]=reloj_digit(x,y,z-1,file,1);
    hijos[1]=reloj_digit(x+23,y,z-1,file,1);
    hijos[2]=reloj_digit(x+46,y,z-1,file,11);
    hijos[3]=reloj_digit(x+55,y,z-1,file,1);
    hijos[4]=reloj_digit(x+78,y,z-1,file,1);
    hijos[5]=reloj_digit(x+101,y,z-1,file,11);
    hijos[6]=reloj_digit(x+110,y,z-1,file,1);
    hijos[7]=reloj_digit(x+133,y,z-1,file,1);
    graph=12;
    flags=4;
    reloj_data.run=false;
    
    loop
        if (reloj_data.run)
            if (reloj_data.cc2<8)
                reloj_data.cc2+=2;
                hijos[7].graph=reloj_data.cc2+1;
            else
                reloj_data.cc2=0;
                hijos[7].graph=1;
                
                if (reloj_data.cc1<9)
                    reloj_data.cc1++;
                    hijos[6].graph=reloj_data.cc1+1;
                else
                    reloj_data.cc1=0;
                    hijos[6].graph=1;
                    
                    if (reloj_data.ss2<9)
                        reloj_data.ss2++;
                        hijos[4].graph=reloj_data.ss2+1;
                    else
                        reloj_data.ss2=0;
                        hijos[4].graph=1;
                        
                        if (reloj_data.ss1<5)
                            reloj_data.ss1++;
                            hijos[3].graph=reloj_data.ss1+1;
                        else
                            reloj_data.ss1=0;
                            hijos[3].graph=1;
                            
                            if (reloj_data.mm2<9)
                                reloj_data.mm2++;
                                hijos[1].graph=reloj_data.mm2+1;
                            else
                                reloj_data.mm2=0;
                                hijos[1].graph=1;
                                
                                if (reloj_data.mm1<9)
                                    reloj_data.mm1++;
                                    hijos[0].graph=reloj_data.mm1+1;
                                else
                                    reloj_data.mm1=0;
                                    hijos[0].graph=reloj_data.mm1+1;
                                end
                            end
                        end
                    end
                end
            end
        end
        frame;
    end
end


process cronometro (x,y,z,file)
private
    int hijos[7];
begin
    priority=10;
    hijos[0]=reloj_digit(x,y,z-1,file,reloj_data.mm1+1);
    hijos[1]=reloj_digit(x+23,y,z-1,file,reloj_data.mm2+1);
    hijos[2]=reloj_digit(x+46,y,z-1,file,11);
    hijos[3]=reloj_digit(x+55,y,z-1,file,reloj_data.ss1+1);
    hijos[4]=reloj_digit(x+78,y,z-1,file,reloj_data.ss2+1);
    hijos[5]=reloj_digit(x+101,y,z-1,file,11);
    hijos[6]=reloj_digit(x+110,y,z-1,file,reloj_data.cc1+1);
    hijos[7]=reloj_digit(x+133,y,z-1,file,reloj_data.cc2+1);
    graph=12;
    reloj_data.end_count=false;
    reloj_data.run=false;
    
    loop
        if (reloj_data.run && !reloj_data.end_count)
            if (reloj_data.cc2>1)
                reloj_data.cc2-=2;
                hijos[7].graph=reloj_data.cc2+1;
            else
                reloj_data.cc2=8;
                hijos[7].graph=10;
                
                if (reloj_data.cc1>0)
                    reloj_data.cc1--;
                    hijos[6].graph=reloj_data.cc1+1;
                else
                    reloj_data.cc1=9;
                    hijos[6].graph=10;
                    
                    if (reloj_data.ss2>0)
                        reloj_data.ss2--;
                        hijos[4].graph=reloj_data.ss2+1;
                    else
                        reloj_data.ss2=9;
                        hijos[4].graph=10;
                        
                        if (reloj_data.ss1>0)
                            reloj_data.ss1--;
                            hijos[3].graph=reloj_data.ss1+1;
                        else
                            reloj_data.ss1=5;
                            hijos[3].graph=6;
                            
                            if (reloj_data.mm2>0)
                                reloj_data.mm2--;
                                hijos[1].graph=reloj_data.mm2+1;
                            else
                                reloj_data.mm2=9;
                                hijos[1].graph=10;
                                
                                if (reloj_data.mm1>0)
                                    reloj_data.mm1--;
                                    hijos[0].graph=reloj_data.mm1+1;
                                else
                                    reloj_data.end_count=true;
                                    reloj_data.run=false;
                                    reloj_data.mm1=0;
                                    reloj_data.mm2=0;
                                    reloj_data.ss1=0;
                                    reloj_data.ss2=0;
                                    reloj_data.cc1=0;
                                    reloj_data.cc2=0;
                                    hijos[0].graph=1;
                                    hijos[1].graph=1;
                                    hijos[3].graph=1;
                                    hijos[4].graph=1;
                                    hijos[6].graph=1;
                                    hijos[7].graph=1;
                                end
                            end
                        end
                    end
                end
            end
        end
        frame;
    end
end
