process menu_image (x,y,z,file,graph,size)
begin
    signal(id,s_freeze);
    frame;
end

process menu (int pointer m_opcion, int pointer m_tiempo)
private
    int m_graficos;
    int m_numbers;
    int m_snumbers;
    int m_titulo[3];
    int m_instrucciones[3];
    
    int m_opcion_valida;
    int m_opcion_horiz;
    int m_opcion_vert;
    int m_opcion_tiempo;
    
    int m_tiempo_temp;
    
    int hijos_titulo[3];
    int hijos_sombra[12];
    int hijo_cursor;
    int hijos_tiempo[1];
    int hijos_instrucciones[3];
    
    int cont;
    int temp_opcion;
begin
    //Carga y creacin de recursos
    m_graficos=load_fpg("grafs/menu_opts.fpg");
    m_numbers=load_fpg("grafs/numbers.fpg");
    m_snumbers=load_fpg("grafs/s_numbers.fpg");
    
    set_text_color(rgb(0,64,21));
    m_titulo[0]=write_in_map(0,"LIQUID",0);
    m_titulo[1]=write_in_map(0,"COUNTER",0);
    set_text_color(rgb(170,225,190));
    m_titulo[2]=write_in_map(0,"LIQUID",0);
    m_titulo[3]=write_in_map(0,"COUNTER",0);
    
    switch (OS_ID)
    case 7,8,9:   //GP2X, WIZ, CAANOO
        set_text_color(rgb(0,64,21));
        m_instrucciones[0]=write_in_map(0,"Use PAD/JOY to change selection",7);
        m_instrucciones[1]=write_in_map(0,"Press B to select",7);
        set_text_color(rgb(170,225,190));
        m_instrucciones[2]=write_in_map(0,"Use PAD/JOY to change selection",7);
        m_instrucciones[3]=write_in_map(0,"Press B to select",7);
    end
    default:    //PC
        set_text_color(rgb(0,64,21));
        m_instrucciones[0]=write_in_map(0,"Use CURSORS to change selection",7);
        m_instrucciones[1]=write_in_map(0,"Press Z to select",7);
        set_text_color(rgb(170,225,190));
        m_instrucciones[2]=write_in_map(0,"Use CURSORS to change selection",7);
        m_instrucciones[3]=write_in_map(0,"Press Z to select",7);
    end
    end //switch
    
    //Texto de ttulo
    hijos_titulo[0]=menu_image(15,5,-1,0,m_titulo[0],300);
    hijos_titulo[1]=menu_image(73,30,-1,0,m_titulo[1],300);
    hijos_titulo[2]=sombra_fija(15,5,0,0,m_titulo[2]);
    hijos_titulo[3]=sombra_fija(73,30,0,0,m_titulo[3]);
    hijos_titulo[2].size=300;
    hijos_titulo[3].size=300;
    //Sombras de opciones y modos de juego
    hijos_sombra[0]=sombra_fija(10,55,1,m_graficos,2);
    hijos_sombra[1]=sombra_fija(90,55,1,m_graficos,4);
    hijos_sombra[2]=sombra_fija(170,55,1,m_graficos,6);
    hijos_sombra[3]=sombra_fija(10,125,1,m_graficos,8);
    hijos_sombra[4]=sombra_fija(90,125,1,m_graficos,10);
    hijos_sombra[5]=sombra_fija(170,125,1,m_graficos,12);
    //Sombra de cuadro de tiempos
    hijos_sombra[6]=sombra_fija(246,50,1,m_graficos,31);
    //Sombras de nmeros de tiempos
    hijos_sombra[ 7]=sombra_fija(262,58,1,m_snumbers,1);
    hijos_sombra[ 8]=sombra_fija(285,58,1,m_snumbers,1);
    hijos_sombra[ 9]=sombra_fija(262,103,1,m_snumbers,1);
    hijos_sombra[10]=sombra_fija(285,103,1,m_snumbers,1);
    hijos_sombra[11]=sombra_fija(262,148,1,m_snumbers,1);
    hijos_sombra[12]=sombra_fija(285,148,1,m_snumbers,1);
    
    //Cursor e indicadores de tiempo
    hijo_cursor=menu_image(10,55,0,m_graficos,1,100);
    hijos_tiempo[0]=menu_image(262,58,0,m_numbers,2,100);
    hijos_tiempo[1]=menu_image(285,58,0,m_numbers,1,100);
    
    //Instrucciones
    //Texto de ttulo
    hijos_instrucciones[0]=menu_image(160,220,-1,0,m_instrucciones[0],100);
    hijos_instrucciones[1]=menu_image(160,230,-1,0,m_instrucciones[1],100);
    hijos_instrucciones[2]=sombra_fija(160,220,0,0,m_instrucciones[2]);
    hijos_instrucciones[3]=sombra_fija(160,230,0,0,m_instrucciones[3]);
    
    
    
    //Inicio de la parte interactiva
    while (teclas[_KEY_ACCEPT] == 1) frame; end
    m_opcion_valida=true;
    m_tiempo_temp=10;
    while ((teclas[_KEY_ACCEPT] != 1) || !m_opcion_valida)
        if (teclas[_KEY_LEFT] == 1)
            switch (m_opcion_horiz)
            case 1,2,3:
                m_opcion_horiz--;
                hijo_cursor.x=10+(80*m_opcion_horiz);
                hijo_cursor.y=55+(70*m_opcion_vert);
                hijo_cursor.graph=(m_opcion_vert*6)+(m_opcion_horiz*2)+1;
                canal_bip_agudo=play_wav(sonido_bip_agudo,0);
            end
            end //switch
        end
        if (teclas[_KEY_RIGHT] == 1)
            switch (m_opcion_horiz)
            case 0,1:
                m_opcion_horiz++;
                hijo_cursor.x=10+(80*m_opcion_horiz);
                hijo_cursor.y=55+(70*m_opcion_vert);
                hijo_cursor.graph=(m_opcion_vert*6)+(m_opcion_horiz*2)+1;
                canal_bip_agudo=play_wav(sonido_bip_agudo,0);
            end
            case 2:
                m_opcion_horiz++;
                hijo_cursor.x=246;
                hijo_cursor.y=50;
                hijo_cursor.graph=30;
                canal_bip_agudo=play_wav(sonido_bip_agudo,0);
            end
            end //switch
        end
        if (teclas[_KEY_UP] == 1)
            if (m_opcion_horiz < 3)
                if (m_opcion_vert > 0)
                    m_opcion_vert--;
                    hijo_cursor.x=10+(80*m_opcion_horiz);
                    hijo_cursor.y=55+(70*m_opcion_vert);
                    hijo_cursor.graph=(m_opcion_vert*6)+(m_opcion_horiz*2)+1;
                    canal_bip_agudo=play_wav(sonido_bip_agudo,0);
                end
            else
                if (m_opcion_tiempo > 0)
                    m_opcion_tiempo--;
                    hijos_tiempo[0].y=58+(45*m_opcion_tiempo);
                    hijos_tiempo[1].y=58+(45*m_opcion_tiempo);
                    switch (m_opcion_tiempo)
                    case 0:
                        hijos_tiempo[0].graph=2;
                        m_tiempo_temp=10;
                    end
                    case 1:
                        hijos_tiempo[0].graph=4;
                        m_tiempo_temp=30;
                    end
                    case 2:
                        hijos_tiempo[0].graph=7;
                        m_tiempo_temp=60;
                    end
                    end //switch
                    canal_bwip=play_wav(sonido_bwip,0);
                end
            end
            
        end
        if (teclas[_KEY_DOWN] == 1)
            if (m_opcion_horiz < 3)
                if (m_opcion_vert < 1)
                    m_opcion_vert++;
                    hijo_cursor.x=10+(80*m_opcion_horiz);
                    hijo_cursor.y=55+(70*m_opcion_vert);
                    hijo_cursor.graph=(m_opcion_vert*6)+(m_opcion_horiz*2)+1;
                    canal_bip_agudo=play_wav(sonido_bip_agudo,0);
                end
            else
                if (m_opcion_tiempo < 2)
                    m_opcion_tiempo++;
                    hijos_tiempo[0].y=58+(45*m_opcion_tiempo);
                    hijos_tiempo[1].y=58+(45*m_opcion_tiempo);
                    switch (m_opcion_tiempo)
                    case 0:
                        hijos_tiempo[0].graph=2;
                        m_tiempo_temp=10;
                    end
                    case 1:
                        hijos_tiempo[0].graph=4;
                        m_tiempo_temp=30;
                    end
                    case 2:
                        hijos_tiempo[0].graph=7;
                        m_tiempo_temp=60;
                    end
                    end //switch
                    canal_bwip=play_wav(sonido_bwip,0);
                end
            end
        end
        
        //Comprobamos si esa opcion es vlida
        if (m_opcion_horiz == 3)
            m_opcion_valida=false;
        else
            //DEBUG****************************************************
            temp_opcion=(3*m_opcion_vert)+m_opcion_horiz;
            switch (temp_opcion)
            case 0,1,2,3,4,5: m_opcion_valida=true; end
            default: m_opcion_valida=false; end
            end //switch
            //*********************************************************
            //m_opcion_valida=true;
        end
        
        frame;
    end
    
    //RELLENAMOS DATOS OBTENIDOS
    //*****************************************************
    temp_opcion=(3*m_opcion_vert)+m_opcion_horiz;
    switch (temp_opcion)
    case 5: *m_opcion=-1; end
    default: *m_opcion=temp_opcion; end
    end //switch
    
    switch (m_opcion_tiempo)
    case 0: *m_tiempo=10; end
    case 1: *m_tiempo=30; end
    case 2: *m_tiempo=60; end
    end //switch
    //*****************************************************
    //DEBUG
    //*********************************************
    //*m_opcion=0;
    //*m_tiempo=10;
    //*********************************************
    
    //Cerrando men
    for (cont=0;cont<=12;cont++)
        if (exists(hijos_sombra[cont])) signal(hijos_sombra[cont],s_kill); end
    end
    if (exists(hijo_cursor)) signal(hijo_cursor,s_kill); end
    for (cont=0;cont<=1;cont++)
        if (exists(hijos_tiempo[cont])) signal(hijos_tiempo[cont],s_kill); end
    end
    for (cont=0;cont<=3;cont++)
        if (exists(hijos_titulo[cont])) signal(hijos_titulo[cont],s_kill); end
    end
    for (cont=0;cont<=3;cont++)
        if (exists(hijos_instrucciones[cont])) signal(hijos_instrucciones[cont],s_kill); end
    end
    
    unload_fpg(m_graficos);
    unload_fpg(m_numbers);
    unload_fpg(m_snumbers);
    for (cont=0;cont<=3;cont++)
        unload_map(0,m_titulo[cont]);
    end
    for (cont=0;cont<=3;cont++)
        unload_map(0,m_instrucciones[cont]);
    end
    
    signal(father,s_wakeup);
    frame;
end
